"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getHitBTCTickerStream = void 0;
var operators_1 = require("rxjs/operators");
var public_ws_handler_1 = require("../../api_clients/hitbtc/public_ws_handler");
var getHitBTCTickerStream = function (pair) {
    var subscriptionData = {
        method: 'subscribeTicker',
        params: {
            symbol: pair.toUpperCase()
        }
    };
    var filterStream = function (_a) {
        var method = _a.method, _b = _a.params, _c = (_b === void 0 ? {} : _b).symbol, symbol = _c === void 0 ? '' : _c;
        return method === 'ticker' && symbol.toUpperCase() === pair.toUpperCase();
    };
    return public_ws_handler_1.getHitBTCPublicObservableFromWS(subscriptionData, filterStream).pipe(operators_1.map(function (_a) {
        var _b = _a.params, _c = _b.last, lastHitBTCprice = _c === void 0 ? '' : _c, timestamp = _b.timestamp;
        return ({
            exchange: 'hitbtc',
            utcTimestamp: new Date(timestamp).getTime(),
            pair: pair,
            price: Number(lastHitBTCprice).toFixed(2),
        });
    }));
};
exports.getHitBTCTickerStream = getHitBTCTickerStream;
